/*
 * @Author: your name
 * @Date: 2021-07-27 19:58:13
 * @LastEditTime: 2021-07-27 20:25:41
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /TracerMethodology_PC/mock/responsibilityCenterConnect.js
 */



import moment from 'moment';
import { parse } from 'url'; // mock tableListDataSource



const genList = (current, pageSize) => {
  const tableListDataSource = [];

  for (let i = 0; i < pageSize; i += 1) {
    const index = (current - 1) * 10 + i;
    tableListDataSource.push({
      key: index,
      id: index,
      responsibilityId: `责任中心id ${index}`,
      responsibilityName: `责任中心名 ${index}`,
      child:[
          {
            key: `one${index}`,
            id: `one${index}`,
            responsibilityName: `责任中心名 ${index}-0`,
            responsibilityId: `责任中心id ${index}-0`,
            departments:[
                {
                    departmentId:`two${index}`,
                    departmentName:`科室名 ${index}`
                },
                {
                    departmentId:`two${index}`,
                    departmentName:`科室名 ${index}`
                }
            ]
          },
          {
            key: index,
            id: index,
            responsibilityName: `责任中心名 ${index}-1`,
            responsibilityId: `责任中心id ${index}-1`,
            departments:[
                {
                    departmentId:index,
                    departmentName:`科室名 ${index}`
                },
                {
                    departmentId:`three${index}`,
                    departmentName:`科室名 ${index}`
                }
            ]
          }
      ],
    //   owner: '曲丽丽',
    //   desc: '这是一段描述',
    //   updatedAt: moment().format('YYYY-MM-DD'),
      createTime: moment().format('YYYY-MM-DD'),
    });
  }
  //   console.log({tableListDataSource});
  tableListDataSource.reverse();
  return tableListDataSource;
};

let tableListDataSource = genList(1, 100);

function getList(req, res, u) {
  let realUrl = u;

  if (!realUrl || Object.prototype.toString.call(realUrl) !== '[object String]') {
    realUrl = req.url;
  }

  const { current = 1, pageSize = 10 } = req.query;
  const params = parse(realUrl, true).query;
  let dataSource = [...tableListDataSource].slice((current - 1) * pageSize, current * pageSize);

  if (params.sorter) {
    const sorter = JSON.parse(params.sorter);
    dataSource = dataSource.sort((prev, next) => {
      let sortNumber = 0;
      Object.keys(sorter).forEach((key) => {
        if (sorter[key] === 'descend') {
          if (prev[key] - next[key] > 0) {
            sortNumber += -1;
          } else {
            sortNumber += 1;
          }

          return;
        }

        if (prev[key] - next[key] > 0) {
          sortNumber += 1;
        } else {
          sortNumber += -1;
        }
      });
      return sortNumber;
    });
  }

  if (params.filter) {
    const filter = JSON.parse(params.filter);

    if (Object.keys(filter).length > 0) {
      dataSource = dataSource.filter((item) => {
        return Object.keys(filter).some((key) => {
          if (!filter[key]) {
            return true;
          }

          if (filter[key].includes(`${item[key]}`)) {
            return true;
          }

          return false;
        });
      });
    }
  }

  if (params.name) {
    dataSource = dataSource.filter((data) => data?.name?.includes(params.name || ''));
  }

  const result = {
    data: {
      list: dataSource,
      totalCount: tableListDataSource.length,
      pageSize: pageSize,
    },
    status: 200,
    success: true,
  };
  return res.json(result);
}

function updateList(req, res, u, b) {
  let realUrl = u;

  if (!realUrl || Object.prototype.toString.call(realUrl) !== '[object String]') {
    realUrl = req.url;
  }

  //   const body = (b && b.body) || req.body;
  const { method, body } = req;
  const { name,isHospital,parentId,parentName} = body;

  switch (method) {
    /* eslint no-case-declarations:0 */
    case 'DELETE':
      const {ids} = body;
      // console.log({realUrl});
      tableListDataSource = tableListDataSource.filter((item) => !ids.includes(item.id));
      break;

    case 'POST':
      (() => {
        const i = Math.ceil(Math.random() * 10000);
        const newRule = {
          key: tableListDataSource.length,
          id:tableListDataSource.length,
          avatar: [
            'https://gw.alipayobjects.com/zos/rmsportal/eeHMaZBwmTvLdIwMfBpg.png',
            'https://gw.alipayobjects.com/zos/rmsportal/udxAbMEhpwthVVcjLXik.png',
          ][i % 2],
          name,isHospital,parentId,parentName,
          createdAt: moment().format('YYYY-MM-DD'),
        };
        tableListDataSource.unshift(newRule);
        return res.json(newRule);
      })();

      return;

    case 'update':
      (() => {
        let newRule = {};
        tableListDataSource = tableListDataSource.map((item) => {
          if (item.key === key) {
            newRule = { ...item, desc, name };
            return { ...item, desc, name };
          }

          return item;
        });
        return res.json(newRule);
      })();

      return;

    default:
      break;
  }

  const result = {
    list: tableListDataSource,
    pagination: {
      total: tableListDataSource.length,
    },
  };
  res.json(result);
}

export default {
  // GET 科室列表

  'GET /api/centerDepartment/list':getList,
  'POST /api/centerDepartment/save': updateList,
};
